# This Makefile.PL for Chess-Plisco was generated by
# Dist::Zilla::Plugin::MakeMaker::Awesome 0.48.
# Don't edit it but the dist.ini and plugins used to construct it.

use strict;
use warnings;

use ExtUtils::MakeMaker;

#! /bin/false

# Copyright (C) 2021 Guido Flohr <guido.flohr@cantanea.com>,
# all rights reserved.

# This program is free software. It comes without any warranty, to
# the extent permitted by applicable law. You can redistribute it
# and/or modify it under the terms of the Do What the Fuck You Want
# to Public License, Version 2, as published by Sam Hocevar. See
# http://www.wtfpl.net/ for more details.

use strict;

use Config;

if ($Config{ivsize} < 8) {
	die "OS unsupported: no support for 64-bit integers.\n";
}

my %WriteMakefileArgs = (
  "ABSTRACT" => "Representation of a chess position with move generator, legality checker etc.",
  "AUTHOR" => "Guido Flohr <guido.flohr\@cantanea.com>",
  "CONFIGURE_REQUIRES" => {
    "ExtUtils::MakeMaker" => 0
  },
  "DISTNAME" => "Chess-Plisco",
  "EXE_FILES" => [
    "bin/plisco"
  ],
  "LICENSE" => "unrestricted",
  "NAME" => "Chess::Plisco",
  "PREREQ_PM" => {
    "Carp" => 0,
    "Chess::Position" => 0,
    "Chess::Position::Macro" => 0,
    "Exporter" => 0,
    "Filter::Util::Call" => 0,
    "IO::Select" => 0,
    "Locale::TextDomain" => 0,
    "PPI::Document" => 0,
    "Scalar::Util" => 0,
    "Time::HiRes" => 0,
    "base" => 0,
    "constant" => 0,
    "integer" => 0,
    "overload" => 0,
    "strict" => 0,
    "warnings" => 0
  },
  "TEST_REQUIRES" => {
    "Chess::PGN::Parse" => 0,
    "Data::Dumper" => 0,
    "File::Basename" => 0,
    "File::Spec" => 0,
    "Test::More" => 0
  },
  "VERSION" => "0.2.0",
  "test" => {
    "TESTS" => "t/*.t"
  }
);

my %FallbackPrereqs = (
  "Carp" => 0,
  "Chess::PGN::Parse" => 0,
  "Chess::Position" => 0,
  "Chess::Position::Macro" => 0,
  "Data::Dumper" => 0,
  "Exporter" => 0,
  "File::Basename" => 0,
  "File::Spec" => 0,
  "Filter::Util::Call" => 0,
  "IO::Select" => 0,
  "Locale::TextDomain" => 0,
  "PPI::Document" => 0,
  "Scalar::Util" => 0,
  "Test::More" => 0,
  "Time::HiRes" => 0,
  "base" => 0,
  "constant" => 0,
  "integer" => 0,
  "overload" => 0,
  "strict" => 0,
  "warnings" => 0
);

unless ( eval { ExtUtils::MakeMaker->VERSION('6.63_03') } ) {
  delete $WriteMakefileArgs{TEST_REQUIRES};
  delete $WriteMakefileArgs{BUILD_REQUIRES};
  $WriteMakefileArgs{PREREQ_PM} = \%FallbackPrereqs;
}

delete $WriteMakefileArgs{CONFIGURE_REQUIRES}
  unless eval { ExtUtils::MakeMaker->VERSION(6.52) };

WriteMakefile(%WriteMakefileArgs);
